%!octave 
%
%     MLP
%      
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.8.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: main.m,v 1.22 2015/06/04 10:44:35 mechanoid Exp mechanoid $

printf("загружаем данные\n");
D=load_data() ;

% D={ {Xl,Yl}, {Xc,Yc} , {Xt,Yt} }
L=D{1};% учебная выборка
C=D{2};% контрольная выборка
T=D{3};% тестовая выборка


sz_in=size(L{1},2) ; % размерность пространства признаков (размер входа сети)
sz_out=size(L{2},2) ; % количество классов

sl = [ sz_in 5 sz_out ] ; % количество слоёв и их размеры (без учёта сдвигов)

% обучение MLP
printf("обучение MLP\n");
W=mlp_init_weigth(sl) ; % начальные матрицы весов
%[W Er]=mlp_trn_gd(L,C,W); % метод обратного распространения
%[W Er]=mlp_trn_gd_moment(L,C,W); % метод обратного распространения с моментами
%[W Er]=mlp_trn_gd_stoch(L,C,W);  % стохастический метод обратного распространения
[W Er]=mlp_trn_gd_stoch_moment(L,C,W);  % стохастический метод обратного распространения


save("-text","result/w.txt", "W" ) ;

plot_error(Er,sl); % рисуем историю изменения ошибки обучения

% тест MLP
printf("тест MLP                         \n");
Yr=mlp_test(T{1},W) ;
qer=msqe(T{2},Yr) ;
save("-text","result/ytr.txt", "Yr" ) ;

% рисуем результат
printf("рисуем результат \n") ;
plot_data(T{1},Yr,"xt-res",qer) ;


