%!octave 
%
%      
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.8.0
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: plot_data.m,v 1.8 2014/05/20 12:55:51 mechanoid Exp $

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = plot_data(X,Y,file,j),
   pix_size="-S640,640";
   pix_font_size=10;
   pix_format="gif";

   xm=ceil(max(max(X))) ; ax=[ 0 xm 0 xm ] ;

   szX=size(X,1) ;

   clf; hold on; axis(ax); grid on; set(gca,'fontsize',pix_font_size); 
   plot_result(X,Y);
   file=sprintf("result/%s.%s",file,pix_format);
   fm=sprintf("-d%s",pix_format);
   if j>0,
	  title(sprintf('results - points: %i, error: %f',szX,j)) ;
   else
	  title(sprintf('points: %i',szX)) ;
   endif
   print(file,fm,pix_size) ;

   retval = 0 ;
endfunction


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
function retval = plot_result(X,Y),
   sz=size(Y,2) ;
   
   [m im]=max(Y') ;

   % clr=jet(sz) ;
   clr=[ 
	 0 0 1 ;
     1 0 0 ;
	 0 1 0 ;
	 1 0 1 ;       
	 1 1 0 ;
	 0 1 1 
   ] ;

   for i=1:sz,
	  ix=find(im==i) ;
	  if size(ix,1)>0 , plot( X(ix,1), X(ix,2), '.', 'color', clr(i,:) ) ; endif
   endfor
   retval=0 ;
endfunction

